#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

ll euclid(ll a, ll b, ll &x, ll &y) {
	if (!b) return x = 1, y = 0, a;
	ll d = euclid(b, a % b, y, x);
	return y -= a/b * x, d;
}

const ll mod = 1000000007; // change to something e l s e
struct Mod {
	ll x;
	Mod(ll xx) : x(xx) {}
	Mod operator+(Mod b) { return Mod((x + b.x) % mod); }
	Mod operator-(Mod b) { return Mod((x - b.x + mod) % mod); }
	Mod operator*(Mod b) { return Mod((x * b.x) % mod); }
	Mod operator/(Mod b) { return *this * invert(b); }
	Mod invert(Mod a) {
		ll x, y, g = euclid(a.x, mod, x, y);
		assert(g == 1); return Mod((x + mod) % mod);
	}
	Mod operator^(ll e) {
		if (!e) return Mod(1);
		Mod r = *this ^ (e / 2); r = r * r;
		return e&1 ? *this * r : r;
	}
};

/**
 * Lessons
 *  - Fractions for modulus
 *  - Using the template
 *  - Strange time complexity...
 *  - Maps
 */
int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T; cin >> T;
	rep(test_case, 0, T) {
		int N; cin >> N;
		string s; cin >> s;

		unordered_map<int, Mod> A, B;
		unordered_map<int, Mod> *curr = &A, *last = &B;

		last->insert({0, Mod(1)});

		rep(i, 0, N - 1) {
			int digit = (s[N - i - 1] == '1') ? 1 : 0;
			curr->clear();

			for(pair<int, Mod> p : *last) {
				int result = digit + p.first;
				Mod prob = p.second;

				if(result % 2 == 1) {
					prob = prob / Mod(2);
					int high = (result + 1) / 2;
					if(curr->find(high) == curr->end()) curr->insert({high, Mod(0)});

					Mod cp = curr->at(high);
					curr->erase(high);
					curr->insert({high, cp + prob});
				}

				int low = result / 2;
				if(curr->find(low) == curr->end()) curr->insert({low, Mod(0)});
				Mod cp = curr->at(low);
				curr->erase(low);
				curr->insert({low, cp + prob});
			}

			swap(curr, last);
		}

		curr->clear();
		for(pair<int, Mod> p : *last) {
			curr->insert({p.first + 1, p.second});
		}
		swap(curr, last);

		Mod result(0);
		int ops = N - 1;
		while(last->size() > 0) {
			curr->clear();

			for(pair<int, Mod> p : *last) {
				if(p.first == 1) {
					result = result + (Mod(ops) * p.second);
					continue;
				}

				Mod prob = p.second;
				int val = p.first;
				if(val % 2 == 1) {
					prob = prob / Mod(2);
					int high = (val + 1) / 2;
					if(curr->find(high) == curr->end()) curr->insert({high, Mod(0)});

					Mod cp = curr->at(high);
					curr->erase(high);
					curr->insert({high, cp + prob});
				}

				int low = val / 2;
				if(curr->find(low) == curr->end()) curr->insert({low, Mod(0)});
				Mod cp = curr->at(low);
				curr->erase(low);
				curr->insert({low, cp + prob});
			}
			ops = ops + 1;
			swap(curr, last);
		}
		cout << result.x << '\n';
	}
}

